=== debian/changelog ===
zmqpp (3.2.0-0ubuntu4) xenial; urgency=medium

  * (Build-)depend on libzmq5-dev.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Mar 2016 19:08:23 +0100

zmqpp (3.2.0-0ubuntu4~gcc5.1) wily; urgency=medium

  * No-change test rebuild for g++5 ABI transition

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 15 Jul 2015 16:30:02 +0000

zmqpp (3.2.0-0ubuntu3) trusty; urgency=low

  * debian/rules:
    - Force -g to allow generating -dbg packages
  * debian/patches/fix_1256886.diff:
    - Fix memory alignment crash issue (LP: #1256886)

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Mon, 02 Dec 2013 14:16:41 +0100

zmqpp (3.2.0-0ubuntu2) trusty; urgency=low

  * debian/control:
    - Add the missing libzmq3-dev dependency to the libzmqpp-dev package
    - Fixed missing dependency on the main library
  * debian/changelog:
    - Use the correct GPL-3 license text for packaging

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Fri, 15 Nov 2013 18:22:31 +0100

zmqpp (3.2.0-0ubuntu1) trusty; urgency=low

  * Initial release

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Tue, 12 Nov 2013 17:25:07 +0100
