=== debian/control ===
Source: zmqpp
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>
Build-Depends: debhelper (>= 9),
               automake,
               libboost-test-dev,
               libzmq5-dev | libzmq-dev,
Standards-Version: 3.9.4
Homepage: https://github.com/benjamg/zmqpp
Vcs-Bzr: lp:zmqpp/ubuntu

Package: libzmqpp3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: High-level C++ bindings for zeromq3
 This C++ binding is a 'high-level' library that hides most of the c-style
 interface core 0mq provides.

Package: libzmqpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libzmqpp3 (= ${binary:Version}),
         libzmq5-dev,
Description: High-level C++ bindings for zeromq3 - development files
 This C++ binding is a 'high-level' library that hides most of the c-style
 interface core 0mq provides.
 This package provides development files and headers.
