=== debian/watch ===
version=3


opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/zmqpp-$1.tar.gz/ \
   https://github.com/benjamg/zmqpp/tags .*/v?(\d\S*)\.tar\.gz
