=== Makefile ===
--- 
+++ 
@@ -3,9 +3,9 @@
 #
 
 CONFIG   = max
-CPPFLAGS = 
-CXXFLAGS = 
-LDFLAGS  = 
+CPPFLAGS =
+CXXFLAGS =
+LDFLAGS  =
 
 PREFIX = /usr/local
 BINDIR = $(DESTDIR)$(PREFIX)/bin
@@ -16,7 +16,7 @@
 # Tools
 #
 
-CXX      = g++
+#CXX      = g++
 LD       = $(CXX)
 AR       = ar
 
@@ -25,9 +25,9 @@
 #
 
 LIBRARY_NAME     = zmqpp
-VERSION_MAJOR    = 3
-VERSION_MINOR    = 2
-VERSION_REVISION = 0
+VERSION_MAJOR    = 4
+VERSION_MINOR    = 1
+VERSION_REVISION = 2
 
 #
 # Paths
@@ -45,6 +45,8 @@
 BUILD_PATH   = ./build/$(CONFIG)-$(CXX)
 OBJECT_PATH  = $(BUILD_PATH)/obj
 
+CUSTOM_INCLUDE_PATH =
+
 #
 # Core values
 #
@@ -53,10 +55,30 @@
 APP_DATESTAMP  = $(shell date '+"%Y-%m-%d %H:%M"')
 
 LIBRARY_SHARED  = lib$(LIBRARY_NAME).so
+LIBRARY_VERSION_SHARED = $(LIBRARY_SHARED).$(VERSION_MAJOR)
+LIBRARY_FULL_VERSION_SHARED = $(LIBRARY_SHARED).$(APP_VERSION)
 LIBRARY_ARCHIVE = lib$(LIBRARY_NAME).a
 CLIENT_TARGET   = $(LIBRARY_NAME)
 TESTS_TARGET    = $(LIBRARY_NAME)-tests
 
+
+# OS Specific values
+
+UNAME_S := $(shell uname -s)
+LD_EXTRA =
+AR_EXTRA = 
+ifeq ($(UNAME_S),Linux)
+	LD_EXTRA += -Wl,-soname -Wl,$(LIBRARY_VERSION_SHARED)
+	AR_EXTRA = crf
+endif
+ifeq ($(UNAME_S),Darwin)
+	LIBRARY_SHARED = lib$(LIBRARY_NAME).dylib
+	LIBRARY_VERSION_SHARED = lib$(LIBRARY_NAME).$(VERSION_MAJOR).dylib
+	LIBRARY_FULL_VERSION_SHARED = lib$(LIBRARY_NAME).$(APP_VERSION).dylib
+	AR_EXTRA = cr
+endif
+
+
 CONFIG_FLAGS =
 ifeq ($(CONFIG),debug)
 	CONFIG_FLAGS = -g -fno-inline -ftemplate-depth-1000
@@ -71,20 +93,16 @@
 	CONFIG_FLAGS = -O3 -funroll-loops -ffast-math -finline-functions -fomit-frame-pointer -DNO_DEBUG_LOG -DNO_TRACE_LOG -DNDEBUG
 endif
 
-COMMON_FLAGS = -MMD -std=c++0x -pipe -Wall -fPIC \
+COMMON_FLAGS = -MMD -std=c++11 -pipe -Wall -fPIC \
 	-DBUILD_ENV=$(CONFIG) \
-	-DBUILD_VERSION='"$(APP_VERSION)"' \
-	-DBUILD_VERSION_MAJOR=$(VERSION_MAJOR) \
-	-DBUILD_VERSION_MINOR=$(VERSION_MINOR) \
-	-DBUILD_VERSION_REVISION=$(VERSION_REVISION) \
 	-DBUILD_DATESTAMP='$(APP_DATESTAMP)' \
 	-DBUILD_LIBRARY_NAME='"$(LIBRARY_NAME)"' \
 	-DBUILD_CLIENT_NAME='"$(CLIENT_TARGET)"' \
-	-I$(SRC_PATH)
+	-I$(SRC_PATH) $(CUSTOM_INCLUDE_PATH)
 
 COMMON_LIBS = -lzmq
 
-LIBRARY_LIBS =  
+LIBRARY_LIBS =
 
 CLIENT_LIBS = -L$(BUILD_PATH) \
 	-l$(LIBRARY_NAME) \
@@ -92,7 +110,9 @@
 
 TEST_LIBS = -L$(BUILD_PATH) \
 	-l$(LIBRARY_NAME) \
-	-lboost_unit_test_framework
+	-lsodium \
+	-lboost_unit_test_framework \
+	-lpthread
 
 ifeq ($(CONFIG),loadtest)
 	CONFIG_FLAGS := $(CONFIG_FLAGS) -DLOADTEST
@@ -124,26 +144,30 @@
 check: $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) test
 
 install:
+	mkdir -p $(INCLUDEDIR)/$(LIBRARY_DIR)
+	mkdir -p $(LIBDIR)
 	install -m 644 $(ALL_LIBRARY_INCLUDES) $(INCLUDEDIR)/$(LIBRARY_DIR)
-	install -m 755 $(BUILD_PATH)/$(LIBRARY_SHARED).$(VERSION_MAJOR) $(LIBDIR)/$(LIBRARY_SHARED).$(APP_VERSION)
-	ln -sf $(LIBRARY_SHARED).$(APP_VERSION) $(LIBDIR)/$(LIBRARY_SHARED).$(VERSION_MAJOR)
-	ln -sf $(LIBRARY_SHARED).$(APP_VERSION) $(LIBDIR)/$(LIBRARY_SHARED)
+	install -m 755 $(BUILD_PATH)/$(LIBRARY_VERSION_SHARED) $(LIBDIR)/$(LIBRARY_FULL_VERSION_SHARED)
+	install -m 755 $(BUILD_PATH)/$(LIBRARY_ARCHIVE) $(LIBDIR)/$(LIBRARY_ARCHIVE)
+	ln -sf $(LIBRARY_FULL_VERSION_SHARED) $(LIBDIR)/$(LIBRARY_VERSION_SHARED)
+	ln -sf $(LIBRARY_FULL_VERSION_SHARED) $(LIBDIR)/$(LIBRARY_SHARED)
 	if [ -f $(BUILD_PATH)/$(CLIENT_TARGET) ]; then install -m 755 $(BUILD_PATH)/$(CLIENT_TARGET) $(BINDIR); fi
 	$(LDCONFIG)
 	@echo "use make installcheck to test the install"
-	
+
 installcheck: $(TESTS_TARGET)
 	$(BUILD_PATH)/$(TESTS_TARGET)
 
 uninstall:
 	rm -rf $(INCLUDEDIR)/$(LIBRARY_DIR)
-	rm -f $(LIBDIR)/$(LIBRARY_SHARED).$(APP_VERSION)
-	rm -f $(LIBDIR)/$(LIBRARY_SHARED).$(VERSION_MAJOR)
+	rm -f $(LIBDIR)/$(LIBRARY_FULL_VERSION_SHARED)
+	rm -f $(LIBDIR)/$(LIBRARY_VERSION_SHARED)
 	rm -f $(LIBDIR)/$(LIBRARY_SHARED)
+	rm -f $(LIBDIR)/$(LIBRARY_ARCHIVE)
 	rm -f $(BINDIR)/$(CLIENT_TARGET)
 
 clean:
-	rm -rf $(BUILD_PATH)
+	rm -rf build/*
 	rm -rf docs
 
 client: $(CLIENT_TARGET)
@@ -155,16 +179,16 @@
 #
 
 $(LIBRARY_SHARED): $(ALL_LIBRARY_OBJECTS)
-	$(LD) $(LDFLAGS) -shared -rdynamic -Wl,-soname -Wl,$(LIBRARY_SHARED).$(VERSION_MAJOR) -o $(BUILD_PATH)/$@.$(VERSION_MAJOR) $^ $(LIBRARY_LIBS) $(COMMON_LIBS)
+	$(LD) $(LDFLAGS) -shared -rdynamic $(LD_EXTRA) -o $(BUILD_PATH)/$(LIBRARY_VERSION_SHARED) $^ $(LIBRARY_LIBS) $(COMMON_LIBS)
 
 $(LIBRARY_ARCHIVE): $(ALL_LIBRARY_OBJECTS)
-	$(AR) crf $(BUILD_PATH)/$@ $^
+	$(AR) $(AR_EXTRA) $(BUILD_PATH)/$@ $^
 
 $(CLIENT_TARGET): $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) $(ALL_CLIENT_OBJECTS)
 	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_CLIENT_OBJECTS) $(CLIENT_LIBS) $(COMMON_LIBS)
 
 $(TESTS_TARGET): $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) $(ALL_TEST_OBJECTS)
-	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_TEST_OBJECTS) $(TEST_LIBS) $(COMMON_LIBS) 
+	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_TEST_OBJECTS) $(TEST_LIBS) $(COMMON_LIBS)
 
 $(TEST_SUITES): $(TESTS_TARGET)
 	LD_LIBRARY_PATH=$(BUILD_PATH):$(LD_LIBRARY_PATH) $(BUILD_PATH)/$(TESTS_TARGET) --log_level=message --run_test=$(patsubst test-%,%,$@)
