=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,5 @@
 
 override_dh_auto_install:
 	dh_auto_install -- PREFIX="/usr" LIBDIR="debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)"
+	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libzmqpp.a
